/***************************************************************************
 *   Copyright (C) 2004 by Christian Hubinger                              *
 *   e9806056@student.tuwien.ac.at                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KFLEVEL_H
#define KFLEVEL_H

/**
@author Christian Hubinger
*/
class KFLevel{
public:
    KFLevel( int, int, int );
    ~KFLevel();
	int getLevel() const {
		return m_level;
	};
	int getMoves() const {
		return m_moves;
	};
	int getMaxAllowedMoves() const {
		return m_maxAllowdMoves;
	};
	
	int getPoints() const;
	int getBonus() const;
	int getScore() const;
	int getMaxPoints() const;
	int getMaxBonus() const;
	
	void finishedLevel( int moves_needed);
protected:
	void setLevel( int );
	void setMoves( int );
	void setSkill( int );
	
private:
	void calculatePoints( int moves_needed );
private:
	int m_level;
	int m_moves;
	int m_points;
	int m_bonus;
	int m_maxPoints;
	int m_maxBonus;
	int m_maxAllowdMoves;
	int m_skill;
	bool m_finished;
};

#endif
